#!/usr/bin/perl -w
#
# $Id: pksd.pl,v 1.2 2003/04/10 06:59:46 rlaager Exp $
# WWW Interface for pksd Administration
# This version was tested with pks version 0.9.6.
#
# Author: Josef Missel
# Contact/Translation: Stephan J. Reichenbach (reichenb@pdkue.bwl.de)
#
# Portions copyright (C) 2003 Josef Missel
# Portions copyright (C) 2003 Stephan J. Reichenbach.
# Portions copyright (C) 2003 Richard Laager.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
# MA 02111-1307, USA.
#

use POSIX;
use locale;
setlocale(LC_CTYPE, "en_EN.ISO-8859-1");

use CGI qw/:standard/;
use CGI::Carp qw/fatalsToBrowser/;

my $FS1 = "<FONT SIZE=+1>";
my $FS3 = "<FONT SIZE=+3>";
my $FFC = "<FONT FACE=\"Courier New,Courier\">";
my $FSE = "</FONT>";
my $PKSDstatus;

my @switcher = param();
if (!defined $switcher[0])
{
    page_header();
    page_bottom();
}
elsif ($switcher[0] eq "delete")
{
    my $ID     = param('id');
    my $passwd = param('passwd');
    Kopf();
    print "Option: delete ID --> $ID<BR><hr>\n";
    if (passwortAbgleich($passwd) == 0)
    {
        my $errno =
          system("/opt/pks/bin/pksclient /opt/pks/var/db delete 0x$ID");
        if ($errno != 0)
        {
            print "While deleting the User-ID: $ID<BR>\n";
            print "an error has occured: $errno auf<BR>\n";
        }
        else
        {
            print "<BR>ID successfully deleted.<BR>\n";
        }
    }
    else
    {
        print "I did not make any changes for securereasons<BR>\n";
    }
}

elsif ($switcher[0] eq "id")
{
    my $ID   = param('id');
    my $name = param('name');
    Kopf();
    print "Option: delete ID --> $FFC $ID $FSE<BR>";
    print "Owner of ID ---->$FFC $name $FSE<BR>\n";
    print "Please enter admin password <BR><HR>\n";
    print start_form(-method => 'POST');
    print p(
            submit(-name => 'delete', -value => ' Delete named ID '),
            "$FFC$FS1 Passwort: $FSE$FSE",
            password_field(-name => 'passwd', -size  => 8,  -maxlength => 8),
            hidden(-name         => 'id',     -value => $ID)
            );
    print end_form();
    print "<HR>\n";
}
elsif ($switcher[0] eq "search")
{
    my $suche = param('search');
    my %Liste = ();
    page_header();
    print "Option: searching for /$suche/<BR>\n";
    print "Please select the ID that you want to delete<BR><HR>\n";
    open L, ("/opt/pks/bin/pksclient /opt/pks/var/db/ index $suche | ");
    while (<L>)
    {
        chomp;
        @tmp = split (" ", $_, 4);
        $tmp[3] =~ s/\</\&lt;/g;
        @id = split "/", $tmp[1];
        $Liste{$tmp[3]} = $id[1];
    }
    close L;
    foreach $u (sort keys %Liste)
    {
        print "$FFC";
        print a({-href => url() . "?id=$Liste{$u}&name=$u"}, $Liste{$u})
          . " $u$FSE<BR>\n";
    }
    page_bottom();
}
elsif ($switcher[0] eq "pksd")
{
    my $pksd      = param('pksd');
    my $verfahren = param('Method');
    my $passwd    = param('Passwd');
    Kopf();
    print "Option: /$verfahren/<BR><HR>\n";

    if ($passwd eq "")
    {
        print "Password missing<BR>\n";
    }
    else
    {
        if (passwortAbgleich($passwd) == 0)
        {
            if ($verfahren eq "PKSD stop")
            {
                print "Stopping PKSD\n<BR>";
                pksStoppen();
            }
            elsif ($verfahren eq "PKSD start")
            {
                print "Starting PKSD\n<BR>";
                pksStarten();
            }
            elsif ($verfahren eq "Reorganisation")
            {
                print "Starting Reorganisation\n<BR>";
                reorganisation();
            }
        }
        else
        {
            print "Have a nice try again...\n<BR>";
        }
    }
    page_bottom();
}
else
{
    page_header();
    print $switcher[0] . "<BR>";
    page_bottom();
}

# ================================== subroutines ==============================
#
sub reorganisation {
    chdir "/opt/pks";
    unlink "ausgabe.txt";
    $errno = system("bin/pksclient var/db/ recover 2>ausgabe.txt");
    print "<BR>";
    open I, "<ausgabe.txt" or die "<ausgabe.txt could not be opened<BR>";
    while (<I>)
    {
        print $_. "<BR>";
    }
    close I;
}

sub pksStarten {
    my $errno = system("/opt/pks/startpks");
    if ($errno == 0)
    {
        print "<BR>PKSD was started<BR>\n";
    }
    else
    {
        print "While starting PKSD an error has occured: $errno auf.\n<BR>";
        print "Please check.\n<BR>";
    }
}

sub pksStoppen {
    my $errno = system("/opt/pks/stoppks");
    if ($errno == 0)
    {
        print "<BR>PKSD was stopped.<BR>";
    }
    else
    {
        print "<BR>While stopping PKSD an error has occured: $errno auf.<BR>\n";
        print "Please check.<BR>\n";
    }
}

sub pksStatus {
    open L, ("ps ax | grep /opt/pks/sbin/pksd |");
    $_ = (<L>);
    close L;
    if (/grep/) { $PKSDstatus = "PKSD start"; }    # luft nicht
    else { $PKSDstatus = "PKSD stop"; }            # luft
}

sub passwortAbgleich {
    my ($pw) = @_;
    $errno = system("su1 /opt/pks/pkstool.pl $pw");
    if ($errno != 0)
    {
        print "Errornumber: $errno<BR>\n";
    }
    return $errno;
}

sub Kopf {
    print header,
      start_html(-title => " Administrationpage of PKSD ", -BGCOLOR => 'white');
}

sub page_header {
    pksStatus();
    print header,
      start_html(-title => " Administrationpage of PKSD ", -BGCOLOR => 'white');
    print "<B>$FFC$FS3" . "Administrating PKSD" . "$FSE$FSE</B><HR>\n";
    print start_form(-method => 'POST');
    print p(
            "$FFC$FS1 Search: $FSE$FSE",
            textfield(-name => 'search', -size  => 25,     -maxlength => 25),
            submit(-name    => 'Suche',  -value => ' Go '),
            );
    print end_form();
    print "<HR>\n";
    print start_form(-method => 'POST');
    print p(
            submit(-name => 'pksd', -value => ' Execute '),
            popup_menu(
                       -name   => 'Method',
                       -values => [$PKSDstatus, 'Reorganisation']
            ),
            password_field(
                           -name      => 'Passwd',
                           -size      => 8,
                           -maxlength => 8,
                           value      => ''
            )
            );
    print end_form();
    print "<HR>\n";
}

sub page_bottom {
    print "</BODY></HTML>";
}
