/*
 * Portions copyright 2002, 2003 Richard Laager.
 * Copyright (c) 1996, 1997, 1998, 1999, Marc Horowitz.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Marc Horowitz.
 * 4. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY MARC HOROWITZ ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL MARC HOROWITZ BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef _KD_INTERNAL_H_
#define _KD_INTERNAL_H_

/*
 * $Id: kd_internal.h,v 1.6 2003/02/28 17:17:15 rlaager Exp $
 */

#include "db_selector.h"
#include "llist.h"

#define TXN_COMMIT(x, y) { (x)->commit((x), 0) ; if ((txn_count++ % KD_MAX_TXN_WO_CKPT)) (y)->dbenv->txn_checkpoint((y)->dbenv, 0, 0, 0); }

#define KEYDB_KEYID_BYTES 4

typedef struct _error
{
  int fatal;
  char *str;
  char buf[1024];
}
error;

extern int num_keydb;
extern DB **keydb_files;
extern DB *keydb (DBT * key), *worddb, *timedb;

#define KD_FIRST_ENTRY(i) (i) = 0
#define KD_LAST_ENTRY(i, dbt) \
(((i)<(dbt).size) && \
 (memcmp(((unsigned char *) (dbt).data) + (i), zeros, 12) != 0))
#define KD_NEXT_ENTRY(i) (i)+=12

int kd_add_userid_to_wordlist (llist * wl,
			       unsigned char *userid, long userid_len);
int kd_keys_elem_marshall (void *e, void *c);
int kd_db_store_keyblock (llist * keys, error * err);

void kd_log_start (char *fct, unsigned char *userid, long len, int flags);
void kd_log_finish (char *fct, int success);

/* from kd_add.c */

int kd_sigs_elem_merge (llist * lout, void *e1, void *e2, void *c);
int kd_userids_elem_merge (llist * lout, void *e1, void *e2, void *c);
int kd_keys_elem_merge (llist * lout, void *e1, void *e2, void *c);

#endif
