/*
 * Portions copyright 2002, 2003 Richard Laager.
 * Copyright (c) 1996, 1997, 1998, 1999, Marc Horowitz.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Marc Horowitz.
 * 4. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY MARC HOROWITZ ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL MARC HOROWITZ BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef _KD_SEARCH_H_
#define _KD_SEARCH_H_

/*
 * $Id: kd_search.h,v 1.6 2003/02/28 17:17:16 rlaager Exp $
 */

#include "kd_internal.h"
#include "kd_types.h"
#include "llist.h"

typedef int (*search_llist_filter) (void *e, llist * new_list,
				    void *c, error * err);

typedef struct _ow_state
{
  unsigned char *userid;
  long userid_len;
  void *c;
  search_llist_filter filter;
  int return_disabled;
  llist_iter append;
  error *err;
}
ow_state;

typedef struct _ki_softerr
{
  int count;
  char buf[1024];
  int keyid_set;
  unsigned char keyid[4];
}
ki_softerr;

int kd_keyblock_iterate (unsigned char *block, long blocklen,
			 llist_iter iter, void *c, error * err,
			 ki_softerr * softerr, int errorhack);
int kd_get_keys_by_keyid (unsigned char *keyid, llist * keys, error * err);
void kd_make_worddb_entry (keys_elem * ke, unsigned char entry[]);
int kd_output_wde (void *e, void *c);
int kd_search_1 (unsigned char *userid, long len, int flags,
		 int maxkeys, llist_iter func, search_llist_filter filt,
		 void *c, error * err);

#endif
