/*
 * Portions copyright 2002, 2003 Richard Laager.
 * Copyright (c) 1996, 1997, 1998, 1999, Marc Horowitz.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Marc Horowitz.
 * 4. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY MARC HOROWITZ ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL MARC HOROWITZ BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef _PKS_CONFIG_H_
#define _PKS_CONFIG_H_

/*
 * $Id: pks_config.h,v 1.10 2003/04/14 19:00:17 rlaager Exp $
 */

#include "llist.h"

typedef struct _pks_config
{
  /* database stuff */
  char pid_dir[1024];
  char chroot_dir[1024];
  int pksd_uid;
  int pksd_gid;
  char db_dir[1024];

  /* web server stuff */
  char www_dir[1024];
  int www_port;
  llist www_addrs;
  int www_readonly;

  /* mail server stuff */
  char socket_name[1024];

  char mail_delivery_client[1024];
  char maintainer_email[1024];
  char mail_intro_file[1024];
  char help_dir[1024];
  char default_lang[1024];

  /* incremental stuff */
  char this_site[1024];
  llist syncsites;

  /* policy stuff */
  int max_last;
  int max_last_reply_keys;
  int max_reply_keys;
}
pks_config;

int pks_read_conf_file (const char *filename, pks_config * pc);

#endif
